#!/home/mfleck/mfleck/schwa/demo/interp

;; University of Illinois/NCSA
;; Open Source License
;; 
;; Copyright © 2005, The Board of Trustees of the University of Illinois.
;; All rights reserved.
;; Developed by:
;; 
;;   Department of Computer Science
;;   University of Illinois, Urbana-Champaign
;;   http://www.cs.uiuc.edu
;; 
;; Permission is hereby granted, free of charge, to any person obtaining
;; a copy of this software and associated documentation files (the
;; "Software"), to deal with the Software without restriction, including
;; without limitation the rights to use, copy, modify, merge, publish,
;; distribute, sublicense, and/or sell copies of the Software, and to
;; permit persons to whom the Software is furnished to do so, subject to
;; the following conditions:
;; 
;;   * Redistributions  of  source  code  must retain the above copyright
;;     notice, this list of conditions and the following disclaimers.
;;   * Redistributions  in binary form must reproduce the above copyright
;;     notice, this  list of conditions and the following disclaimers in
;;     the documentation and/or other materials provided with the
;;     distribution.
;;   * Neither the names of the Department of Computer Science,
;;     University of Illinois, Urbana-Champaign, nor the names of its
;;     contributors may be used to endorse or promote products derived 
;;     from this Software without specific prior written permission.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
;; IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
;; ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
;; CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
;; WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.




;; Script to extract entries for specific words from a larger
;; dictionary file, e.g. the CMU dictionary.  This was used
;; to create the short demo dictionary.   

;; It assumes that the dictionary is formatted so each entry
;; occupies a single line.  

;; You will probably need to edit the filename for the dictionary
;; file.

;; This is not a particularly fast way to do this task if the
;; list of words is long.   Rather, this is an example of a
;; special-purpose throw-away script.

(debug_on)

;; infile should contain a list of words with no duplicates
;; e.g. smallwords.txt.   
(set usage "Usage:  ./extract_words.scm infile outfile")

(when (not (equal (length *args*) 2))
      (error "Wrong number of args \n %x\n" usage)) 

(set dictfile "/corpora/cmudict/cmudict.0.6")
(set infile (car *args*))
(set outfile (cadr *args*))

(set wordlist (read_file infile))

(remove_file outfile)
(dolist (word wordlist)
	(extract_entry dictfile word outfile))
