#!/home/mfleck/mfleck/schwa/demo/interp

;; University of Illinois/NCSA
;; Open Source License
;; 
;; Copyright © 2005, The Board of Trustees of the University of Illinois.
;; All rights reserved.
;; Developed by:
;; 
;;   Department of Computer Science
;;   University of Illinois, Urbana-Champaign
;;   http://www.cs.uiuc.edu
;; 
;; Permission is hereby granted, free of charge, to any person obtaining
;; a copy of this software and associated documentation files (the
;; "Software"), to deal with the Software without restriction, including
;; without limitation the rights to use, copy, modify, merge, publish,
;; distribute, sublicense, and/or sell copies of the Software, and to
;; permit persons to whom the Software is furnished to do so, subject to
;; the following conditions:
;; 
;;   * Redistributions  of  source  code  must retain the above copyright
;;     notice, this list of conditions and the following disclaimers.
;;   * Redistributions  in binary form must reproduce the above copyright
;;     notice, this  list of conditions and the following disclaimers in
;;     the documentation and/or other materials provided with the
;;     distribution.
;;   * Neither the names of the Department of Computer Science,
;;     University of Illinois, Urbana-Champaign, nor the names of its
;;     contributors may be used to endorse or promote products derived 
;;     from this Software without specific prior written permission.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
;; IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
;; ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
;; CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
;; WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.





;; Convert an HTML file to tokenized plain text

;; Usage:
;;
;; ./html2txt.scm gettysburg.html | more

(if (null *args*)
    (error "Too few args for script\n"))

;; A list of all tags for which we want to omit the whole block delimited
;;   by matching start and end tags.
(set skiplist '(script style form iframe))

;; A list of tags that should cause a paragraph break in the output
(set breaklist '(p br div tr li))

;; Read the input file into memory.  (We assume it's not large and not compressed.)
(set sgml (read_sgml_file (car *args*) 0 skiplist))

;; Extract the body of the html markup
(set body (extract_sgml_block sgml 'body))

(when (present body)
      ;; Convert it to a list of plaintext utterances
      (set text (sgml2txt body breaklist))

      ;; Tokenize the plaintext and print it out nicely
      (show_utterances *stdout* (tokenize_utterances text)))


