#!/home/mfleck/mfleck/schwa/demo/interp

;; University of Illinois/NCSA
;; Open Source License
;; 
;; Copyright © 2005, The Board of Trustees of the University of Illinois.
;; All rights reserved.
;; Developed by:
;; 
;;   Department of Computer Science
;;   University of Illinois, Urbana-Champaign
;;   http://www.cs.uiuc.edu
;; 
;; Permission is hereby granted, free of charge, to any person obtaining
;; a copy of this software and associated documentation files (the
;; "Software"), to deal with the Software without restriction, including
;; without limitation the rights to use, copy, modify, merge, publish,
;; distribute, sublicense, and/or sell copies of the Software, and to
;; permit persons to whom the Software is furnished to do so, subject to
;; the following conditions:
;; 
;;   * Redistributions  of  source  code  must retain the above copyright
;;     notice, this list of conditions and the following disclaimers.
;;   * Redistributions  in binary form must reproduce the above copyright
;;     notice, this  list of conditions and the following disclaimers in
;;     the documentation and/or other materials provided with the
;;     distribution.
;;   * Neither the names of the Department of Computer Science,
;;     University of Illinois, Urbana-Champaign, nor the names of its
;;     contributors may be used to endorse or promote products derived 
;;     from this Software without specific prior written permission.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
;; IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
;; ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
;; CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
;; WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.





;; Convert an HTML file to plain text

;; This does an ok job of converting HTML pages to plain text.
;; You can tweak its behavior for specific applications by modifying
;;   parameters.

;; The following adaptations are especially worth noting:
;;     -- Try changing the contents of skiplist and breaklist,
;;        e.g. some HTML pages benefit from ignoring text inside hyperlinks
;;     -- For SGML and XML, either skip the body-extraction step or
;;        use a more appropriate label (e.g. 'text, 'doc)
;;     -- Files containing multiple documents can be read section-by-section 
;;        (e.g. one news story at a time).  This is especially useful when
;;        the input file is very large.  See read_sgml_block in tools/sgml.c.
;;     -- For XML, set the preservecase option for read_sgml_file
;;        (XML distinguishes upper and lower case)

;; Usage:
;;
;; ./html2txt.scm gettysburg.html | more

(if (null *args*)
    (error "Too few args for script\n"))

;; A list of all tags for which we want to omit the whole block delimited
;;   by matching start and end tags.
(set skiplist '(script style form iframe))

;; A list of tags that should cause a paragraph break in the output
(set breaklist '(p br div tr li))

;; Read the input file into memory.  (We assume it's not large and not compressed.)
(set sgml (read_sgml_file (car *args*) 0 skiplist))

;; Extract the body of the html markup
(set body (extract_sgml_block sgml 'body))

(when (present body)
      ;; Convert it to a list of plaintext utterances
      (set text (sgml2txt body breaklist))
      
      ;; Print them out nicely
      (show_utterances *stdout* text))


