#!/home/mfleck/mfleck/schwa/demo/interp

;; University of Illinois/NCSA
;; Open Source License
;; 
;; Copyright © 2005, The Board of Trustees of the University of Illinois.
;; All rights reserved.
;; Developed by:
;; 
;;   Department of Computer Science
;;   University of Illinois, Urbana-Champaign
;;   http://www.cs.uiuc.edu
;; 
;; Permission is hereby granted, free of charge, to any person obtaining
;; a copy of this software and associated documentation files (the
;; "Software"), to deal with the Software without restriction, including
;; without limitation the rights to use, copy, modify, merge, publish,
;; distribute, sublicense, and/or sell copies of the Software, and to
;; permit persons to whom the Software is furnished to do so, subject to
;; the following conditions:
;; 
;;   * Redistributions  of  source  code  must retain the above copyright
;;     notice, this list of conditions and the following disclaimers.
;;   * Redistributions  in binary form must reproduce the above copyright
;;     notice, this  list of conditions and the following disclaimers in
;;     the documentation and/or other materials provided with the
;;     distribution.
;;   * Neither the names of the Department of Computer Science,
;;     University of Illinois, Urbana-Champaign, nor the names of its
;;     contributors may be used to endorse or promote products derived 
;;     from this Software without specific prior written permission.
;; 
;; THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;; EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
;; IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
;; ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
;; CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
;; WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.




;; Interactive access to a dictionary in
;; CMU dictionary format.   
;; Margaret M. Fleck, 2005

;; This script reads in the dictionary and then leaves you with
;; a live interpreter session.  The function lookup can be used 
;; to look up words, e.g. 
;;    (lookup 'battlefield)
;; The function (exit) or typing ctrl-D twice will terminate the
;; interactive session.


(leave_live)

(when (not (equal (length *args*) 0))
      (error "Usage:  ./showdict.scm \n   (no input args)\n"))


;; If you have the full CMU pronouncing dictionary,
;; you can edit this line to point to it instead.
(set cmudict (read_cmudict "shortdict"))

(set lookup 
     (lambda (x)
       (write_infull (hashget cmudict (token2lower x)))
       (format "\n\n")))
	      


