/*
University of Illinois/NCSA
Open Source License

Copyright © 2005, The Board of Trustees of the University of Illinois.
All rights reserved.
Developed by:

  Department of Computer Science
  University of Illinois, Urbana-Champaign
  http://www.cs.uiuc.edu

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

  * Redistributions  of  source  code  must retain the above copyright
    notice, this list of conditions and the following disclaimers.
  * Redistributions  in binary form must reproduce the above copyright
    notice, this  list of conditions and the following disclaimers in
    the documentation and/or other materials provided with the
    distribution.
  * Neither the names of the Department of Computer Science,
    University of Illinois, Urbana-Champaign, nor the names of its
    contributors may be used to endorse or promote products derived 
    from this Software without specific prior written permission.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.

*/


#ifndef schwaearray
#define schwaearray

#include "schwa.h"

struct earray {
  Hashtable *table;          /* Hashtable mapping block ID's to blocks of data */
  unsigned short width;      /* How many bytes in each stored element? */
};

typedef struct earray Earray;

struct earrayptr {
  Hashptr *iter;             /* Iterator for the underlying hash table. */
  char *currentblock;        /* Block currently being searched. */
  unsigned int currentbase;  /* Base location of current block */
  unsigned int currentpos;   /* Next unsearched position in it. */
  unsigned int width;        /* How many bytes in each stored element? */
};

typedef struct earrayptr Earrayptr;

Earray *new_earray(unsigned int width);
void *earray_ref(Earray *table, unsigned long position);
int earray_isset(Earray *table, unsigned long position);
Earrayptr *earraystart(Earray *table);
void *earraynext(Earrayptr *ptr, unsigned long *position);

#endif


