/*
University of Illinois/NCSA
Open Source License

Copyright © 2005, The Board of Trustees of the University of Illinois.
All rights reserved.
Developed by:

  Department of Computer Science
  University of Illinois, Urbana-Champaign
  http://www.cs.uiuc.edu

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal with the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

  * Redistributions  of  source  code  must retain the above copyright
    notice, this list of conditions and the following disclaimers.
  * Redistributions  in binary form must reproduce the above copyright
    notice, this  list of conditions and the following disclaimers in
    the documentation and/or other materials provided with the
    distribution.
  * Neither the names of the Department of Computer Science,
    University of Illinois, Urbana-Champaign, nor the names of its
    contributors may be used to endorse or promote products derived 
    from this Software without specific prior written permission.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.

*/


#ifndef schwautils
#define schwautils

/* This list of includes contains not only those required to compile utils.c, but
   also some other extremely standard libraries. */

#define GC_DEBUG  /* toggle on the GC's debugging features */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include "gc.h"
#include <string.h>
#include <ctype.h>
#include <unistd.h>  
#include <setjmp.h>

void die(const char *format, ...);
void error(const char *format, ...);
char *gcprintf(const char *fmt, ...);
unsigned long hashstring(const char* key, unsigned long tablesize);
unsigned long hashint (unsigned long input, unsigned int shift);
unsigned long findhashprime (unsigned long target);
char *read_token (FILE *infile);
char *sread_token(char **string);
char *copystring (char *input);
char *substring (char *start, char *end);
void *safe_malloc(size_t nbytes);
void *safe_malloc_atomic(size_t nbytes);
void *safe_realloc(void *old, size_t newsize);
char *getline(FILE *infile);

extern char *optarg;
extern int optind;

extern int errorjump;
extern jmp_buf errorenv;

#endif

